use std::io::{stdout, Write};
use std::{env, thread};
use zbus::blocking::Connection;
use zbus::{proxy, Result};

#[proxy(
    interface = "org.freedesktop.Notifications",
    default_service = "org.freedesktop.Notifications",
    default_path = "/org/freedesktop/Notifications"
)]
trait MyGreeter {
    fn notify(
        &self,
        something: &str,
        semothing_2: u32,
        title: &str,
        body: &str,
    ) -> Result<String>;
}

fn send_dbus_timer_out() {
    let connection = Connection::session().unwrap();
    let proxy = MyGreeterProxyBlocking::new(&connection).unwrap();
    proxy.notify("", 0, "a", "b").unwrap();
}

fn main() {
    let total_duration: u32 = env::args().nth(1).unwrap().parse::<u32>().unwrap() * 60;

    for n in 0..(total_duration) {
        let left = total_duration - n;
        print!("\r{:02}:{:02} left", left / 60, left % 60);
        stdout().flush().unwrap();
        thread::sleep(std::time::Duration::from_secs(1));
    }

    // send_dbus_timer_out();
}
